unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ReportField, Spin, Buttons;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    RAlignment: TComboBox;
    Label1: TLabel;
    RBorderTop: TCheckBox;
    RBorderLeft: TCheckBox;
    RBorderRight: TCheckBox;
    RBorderBottom: TCheckBox;
    RBorderStyle: TComboBox;
    Label2: TLabel;
    RBorderWidth: TSpinEdit;
    Label3: TLabel;
    ColorDialog1: TColorDialog;
    RColor: TBitBtn;
    RCrossOut: TComboBox;
    Label4: TLabel;
    RDividerHeight: TComboBox;
    Label5: TLabel;
    RDividerStyle: TComboBox;
    Label6: TLabel;
    RFixLength: TCheckBox;
    FontDialog1: TFontDialog;
    RFont: TBitBtn;
    Label7: TLabel;
    RMaxLength: TSpinEdit;
    RTransparent: TCheckBox;
    RWordWrap: TCheckBox;
    CheckBox1: TCheckBox;
    REnabled: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    Label8: TLabel;
    RWidth: TSpinEdit;
    Label9: TLabel;
    RHeight: TSpinEdit;
    ReportField1: TReportField;
    procedure ListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RAlignmentClick(Sender: TObject);
    procedure RBorderWidthChange(Sender: TObject);
    procedure RColorClick(Sender: TObject);
    procedure RBorderTopClick(Sender: TObject);
    procedure RBorderLeftClick(Sender: TObject);
    procedure RBorderRightClick(Sender: TObject);
    procedure RBorderBottomClick(Sender: TObject);
    procedure RCrossOutClick(Sender: TObject);
    procedure RDividerHeightClick(Sender: TObject);
    procedure RDividerStyleClick(Sender: TObject);
    procedure RFixLengthClick(Sender: TObject);
    procedure RFontClick(Sender: TObject);
    procedure RMaxLengthChange(Sender: TObject);
    procedure RTransparentClick(Sender: TObject);
    procedure RWordWrapClick(Sender: TObject);

    procedure ControlMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ControlMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ControlMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CheckBox1Click(Sender: TObject);
    procedure REnabledClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RWidthChange(Sender: TObject);
    procedure RHeightChange(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ReportField1StyleChange(Sender: TObject);
    procedure RBorderStyleClick(Sender: TObject);
  private
    Sh1: TControl;
    Shx, Shy: Integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  v: TReportFieldVar;

implementation

{$R *.DFM}

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex < 0 then exit;
  ReportField1.Text:=ListBox1.items[ListBox1.ItemIndex];
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ReportField1StyleChange(Sender);
  sh1:=Nil;
  V:=ReportField1.GetStyle;
end;

procedure TForm1.RAlignmentClick(Sender: TObject);
begin
  ReportField1.Alignment:=TAlignment(RAlignment.ItemIndex);
end;

procedure TForm1.RBorderStyleClick(Sender: TObject);
begin
  ReportField1.BorderStyle:=TPenStyle(RBorderStyle.ItemIndex);
end;

procedure TForm1.RBorderWidthChange(Sender: TObject);
begin
  ReportField1.BorderWidth:=RBorderWidth.Value;
end;

procedure TForm1.RColorClick(Sender: TObject);
begin
  if ColorDialog1.Execute then
    ReportField1.BackColor:=ColorDialog1.Color;
end;

procedure TForm1.RBorderTopClick(Sender: TObject);
begin
  ReportField1.Border.Top:=RBorderTop.Checked;
end;

procedure TForm1.RBorderLeftClick(Sender: TObject);
begin
  ReportField1.Border.Left:=RBorderLeft.Checked;
end;

procedure TForm1.RBorderRightClick(Sender: TObject);
begin
  ReportField1.Border.Right:=RBorderRight.Checked;
end;

procedure TForm1.RBorderBottomClick(Sender: TObject);
begin
  ReportField1.Border.Bottom:=RBorderBottom.Checked;
end;

procedure TForm1.RCrossOutClick(Sender: TObject);
begin
  ReportField1.CrossOut:=TCrossOut(RCrossOut.ItemIndex);
end;

procedure TForm1.RDividerHeightClick(Sender: TObject);
begin
  ReportField1.DividerHeight:=TDividerHeight(RDividerHeight.ItemIndex);
end;

procedure TForm1.RDividerStyleClick(Sender: TObject);
begin
  ReportField1.DividerStyle:=TPenStyle(RDividerStyle.ItemIndex);
end;

procedure TForm1.REnabledClick(Sender: TObject);
begin
  ReportField1.Enabled:=REnabled.Checked;
end;

procedure TForm1.RFixLengthClick(Sender: TObject);
begin
  ReportField1.FixLength:=RFixLength.Checked;
  RDividerStyle.ItemIndex:=Ord(ReportField1.DividerStyle);
end;

procedure TForm1.RFontClick(Sender: TObject);
begin
  if FontDialog1.Execute then
    ReportField1.Font:=FontDialog1.Font;
end;

procedure TForm1.RWidthChange(Sender: TObject);
begin
  if Length(RWidth.Text) < 1 then exit;
  if (RWidth.Value >= RWidth.MinValue) and (RWidth.Value <= RWidth.MaxValue) then
    ReportField1.Width:=RWidth.Value;
end;

procedure TForm1.RHeightChange(Sender: TObject);
begin
  if Length(RHeight.Text) < 1 then exit;
  if (RHeight.Value >= RHeight.MinValue) and (RHeight.Value <= RHeight.MaxValue) then
    ReportField1.Height:=RHeight.Value;
end;

procedure TForm1.RMaxLengthChange(Sender: TObject);
begin
  if Length(RMaxLength.Text) < 1 then exit;
  ReportField1.MaxLength:=RMaxLength.Value;
end;

procedure TForm1.RTransparentClick(Sender: TObject);
begin
  ReportField1.Transparent:=RTransparent.Checked;
end;

procedure TForm1.RWordWrapClick(Sender: TObject);
begin
  ReportField1.WordWrap:=RWordWrap.Checked;
end;

procedure TForm1.ControlMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) and CheckBox1.Checked then begin
    sh1:=TControl(Sender);
    shx:=x;
    shy:=y;
    sh1.BringToFront;
    Form1.Caption:=Sh1.name + ' [' + IntToStr(Sh1.Left) + '/' + IntToStr(Sh1.Top) + ']';
  end;
end;

procedure TForm1.ControlMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var vx, vy: integer;
begin
  Form1.Caption:=TControl(Sender).Name + ' [' + IntToStr(TControl(Sender).Left) + '/' +
                 IntToStr(TControl(Sender).Top) + ']';
  if (Sh1 <> Nil) and CheckBox1.Checked then begin
    vx:=Sh1.Left - shx + x;
    vy:=Sh1.Top - shy + y;
    //
    if (vx + Sh1.Width) > Form1.ClientWidth then vx:=Form1.ClientWidth - Sh1.Width;
    if (vy + Sh1.Height) > Form1.ClientHeight then vy:=Form1.ClientHeight - Sh1.Height;
    if vx < 1 then vx:=1;
    if vy < 1 then vy:=1;
    //
    Sh1.Left:=vx;
    Sh1.Top:=vy;
    Form1.Caption:=Sh1.name + ' [' + IntToStr(vx) + '/' + IntToStr(vy) + ']';
    Application.ProcessMessages;
  end;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Form1.Caption:=Form1.Name;
end;

procedure TForm1.ControlMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) and CheckBox1.Checked then begin
    sh1:=Nil;
    Form1.Caption:=Form1.Name;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
    ReportField1.Cursor:=crHandPoint
  else
    ReportField1.Cursor:=crDefault;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  v:=ReportField1.GetStyle;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ReportField1.SetStyle(V);
end;

procedure TForm1.ReportField1StyleChange(Sender: TObject);
begin
  RAlignment.ItemIndex:=Ord(ReportField1.Alignment);
  RBorderTop.Checked:=ReportField1.Border.Top;
  RBorderLeft.Checked:=ReportField1.Border.Left;
  RBorderRight.Checked:=ReportField1.Border.Right;
  RBorderBottom.Checked:=ReportField1.Border.Bottom;
  RBorderStyle.ItemIndex:=Ord(ReportField1.BorderStyle);
  RBorderWidth.Value:=ReportField1.BorderWidth;
  ColorDialog1.Color:=ReportField1.BackColor;
  RCrossOut.ItemIndex:=Ord(ReportField1.CrossOut);
  RDividerHeight.ItemIndex:=Ord(ReportField1.DividerHeight);
  RDividerStyle.ItemIndex:=Ord(ReportField1.DividerStyle);
  RFixLength.Checked:=ReportField1.FixLength;
  FontDialog1.Font:=ReportField1.Font;
  RMaxLength.Value:=ReportField1.MaxLength;
  RTransparent.Checked:=ReportField1.Transparent;
  RWordWrap.Checked:=ReportField1.WordWrap;
  REnabled.Checked:=ReportField1.Enabled;
  RWidth.Value:=ReportField1.Width;
  RHeight.Value:=ReportField1.Height;
end;

end.
